--version 0.8.2

local x = 420
local y = 990





local maxHP = 100
local nowHP = 100
local lanterne = 0
local recupHP = 0
local sharpLv = 1
local currentStamina = 0 
local maxStamina = 0
local gaugeSeparator = 40
local currentSharpness = 0
local maxSharpness = 0
local currentLv = 0
local currentLvGaugeLength = 0
local maxLv = 0
local treshold = 40
local debuff = 0
local status = 1
local playerCount = 1

local playerId = 0
local hunterCount = 0
local font = nil


local switch_flow = -1
local switch_flowMax = -1
local switch_currentFocus = -1
local switch_lowFocus = -1

local charge_charged_timer = -1
local charge_axe_timer = -1
local charge_shield_timer = -1
local charge_chargeBottle_num = -1
local charge_maxBottles = -1
local charge_BootleGauge = -1
local charge_axe_mode = -1

local hammer_charge = -1

local dual_state= -1
local dual_gauge = 0
local dual_max = -1

local insect_timer = -1

local bow_charge = -1

local gunlance_canUsePile = -1
local gunlance_getBulletCount = -1
local gunlance_getMaxBulletCount = -1
local gunlance_getReloadTime = -1

local long_lvl = -1
local long_gaugeTimer = -1
local long_gauge = -1

local hunt_revolt = -1

local heavy_shotLvl = -1
local heavy_bigTimmer = -1
local heavy_mode = -1
local heavy_bullet = -1

local class
local ok = false
local in_quest = false
local room
local questStatus = -1

local skill
local vaillant = -1


local conf = json.load_file("KH_HUD.json")

if not conf then
    conf = {
        x = 420,
        y = 990,
    }
end

re.on_config_save(
    function()
        json.dump_file("KH_HUD.json", conf)
    end
)

re.on_draw_ui(
    function() 
        if not imgui.collapsing_header("Kingdom Hearts HUD") then return end

        local changed, value

        changed, value = imgui.slider_int("Bar: x position", conf.x, 0, 5000)
        if changed then conf.x = value end

        changed, value = imgui.slider_int("Bar: y position", conf.y, 0, 4000)
        if changed then conf.y = value end

        if imgui.button("Save") then
            json.dump_file("KH_HUD.json", conf)
        end

    end
)

local function on_player_update(args)

    local playerBase = sdk.get_managed_singleton("snow.player.PlayerManager")
    
    if not playerBase then 
        return
    end
    
    playerBase = playerBase:call("findMasterPlayer")

    if not playerBase then 
        return
    end

	local playerData = playerBase:call("get_PlayerData")

    if not playerData then 
        return
    end

	maxHP = playerData:get_field("_vitalMax")

    if not maxHP then
        return
    end

	nowHP = playerData:call("get__vital")
	recupHP = playerData:get_field("_r_Vital") - nowHP
    lanterne = playerData:get_field("_VitalEc")

    currentSharpness = playerBase:call("get_SharpnessGauge")
    maxSharpness = playerBase:call("get_SharpnessGaugeMax")
    
    currentLv = math.floor(playerBase:call("get_SharpnessLv"))
    currentLvGaugeLength = playerBase:call("getSharpnessLvLength", currentLv)
    maxLv = playerBase:call("getSharpnessLvToGauge", maxSharpness)
    
    for level = maxLv, currentLv, -1 do
        maxSharpness = maxSharpness - playerBase:call("getSharpnessLvLength", level)
    end

    currentSharpness = currentSharpness - maxSharpness
    maxSharpness = currentLvGaugeLength

    currentStamina = math.floor(playerData:get_field("_stamina"))
    maxStamina = math.floor(playerData:get_field("_staminaMax"))

    debuff = playerData:get_field("_condition"):call("get_DebuffCondition")

    class = playerBase:get_type_definition():get_full_name()

    if class == "snow.player.GunLance" then
        gunlance_canUsePile = playerBase:get_field("_CanUsePile")
        gunlance_getBulletCount = playerBase:call("get_BulletCount")  
        gunlance_getMaxBulletCount = playerBase:call("get_MaxBulletCount") 
        gunlance_getReloadTime = playerBase:call("get_ChargeDragonSlayCannonTime")
    end
     
    if class == "snow.player.Hammer" then
        hammer_charge = playerBase:call("get_NowChargeType") 
    end

    if class == "snow.player.SlashAxe" then
        switch_currentFocus = playerBase:get_field("_BottleGauge")
        switch_flow = playerBase:get_field("_BottleAwakeGauge")
        switch_lowFocus = playerBase:get_field("_BottleGaugeLow")
        switch_flowMax = playerBase:call("get_BottleAwakeGaugeMax") 
    end

    if class == "snow.player.DualBlades" then
        dual_state = playerBase:call("get_DBState") 
        dual_gauge = playerBase:call("get_KijinKyoukaGuage")
        dual_max = playerBase:get_field("KijinKyoukaGuage_Max")
    end

    if class == "snow.player.ChargeAxe" then
        charge_charged_timer = playerBase:get_field("_BottleAwakeDurationTimer") 
        charge_shield_timer = playerBase:get_field("_ShieldBuffTimer") 
        charge_axe_timer = playerBase:get_field("_SwordBuffTimer") 
        charge_chargeBottle_num = playerBase:call("get_ChargedBottleNum") 
        charge_maxBottles = playerBase:call("getBottleNumMax") 
        charge_BootleGauge = playerBase:get_field("_ChargeGauge")
        charge_axe_mode = playerBase:call("get_Mode")
    end

    
    if class == "snow.player.LongSword" then
        long_gauge = playerBase:get_field("_LongSwordGauge")
        long_lvl = playerBase:get_field("_LongSwordGaugeLv")
        long_gaugeTimer = playerBase:get_field("_LongSwordGaugeLvTimer")
    end

    if class == "snow.player.Bow" then
        bow_charge = playerBase:call("get_ChargeLv")
    end

    if class == "snow.player.Horn" then
        hunt_revolt = playerBase:call("get_RevoltGuage")
    end

    if class == "snow.player.HeavyBowgun" then
        heavy_shotLvl = playerBase:get_field("_ShotChargeLv")
        heavy_bigTimmer = playerBase:call("get_SpecialBulletTimer")
        heavy_mode = playerBase:call("get_SpecialMode")
        heavy_bullet = playerBase:call("get_SpecialBullet")
    end

    --in_quest = false

    local quest = sdk.get_managed_singleton("snow.QuestManager")
    
    if not quest then
        return
    end

    questStatus = quest:get_field("_QuestStatus")

    if questStatus == 2 then
        in_quest = true
        return
    end

    if questStatus > 2 then
        in_quest = false
        return
    end

	if questStatus < 2 then
		if sdk.get_managed_singleton("snow.VillageAreaManager") then
			room = sdk.get_managed_singleton("snow.VillageAreaManager"):call("get__CurrentAreaNo")
            if room == 5 then
                in_quest = true
            else
                in_quest = false
            end
		end
    --else
    --    in_quest = true
	end
	
end


local function drawFlow(x,y,thickness,outColor,currentFocus,lowFocus,flow,flowMax)

    local flow_slength = 30;
    local flow_blength = 70;
    local flow_shigh = 12;
    local flow_bhigh = 20;
    local flow_total  
    local flow_progress  
    local flow_left  
    local flow_tan 
    local flowoffsetx = 0
    local flowoffsety = 0

 
    ax = x + 40
    ay = y + 18
    bx = x + 40
    by = y + 18 - flow_shigh
    cx = x + 40 + flow_slength
    cy = y + 18 - flow_shigh
    dx = x + 40 + flow_slength + flow_blength
    dy = y + 18 - flow_shigh - flow_bhigh
    ex = x + 40 + flow_slength + flow_blength + flow_slength
    ey = y + 18 - flow_shigh - flow_bhigh
    fx = x + 40 + flow_slength + flow_blength + flow_slength
    fy =  y + 18

    flow_total = flow_slength * 2 + flow_blength;
    flow_progress = (flow * flow_total) / flowMax;
   
    if(flow > 0) then
    
        if (flow_progress >= (flow_slength + flow_blength)) then

            flow_left = flow_progress - flow_slength - flow_blength;

            ex = x + 40 + flow_slength + flow_blength + flow_left
            ey = y + 18 - flow_shigh - flow_bhigh

            fx = x + 40 + flow_slength + flow_blength + flow_left
            fy = y + 18
    
        elseif (flow_progress > flow_slength) then

            flow_left = flow_progress - flow_slength;
            flow_tan = flow_bhigh / flow_blength;
    
            dx = x + 40 + flow_slength + flow_left
            dy = y + 18 - flow_shigh - (flow_tan * (flow_left))

            ex = dx
            ey = y + 18

            fx = ex
            fy = ey
        
        elseif (flow_progress > 0) then

            flow_left = flow_progress;

            cx = x + 40 + flow_left
            cy = y + 18 - flow_shigh

            dx = cx
            dy = cy

            ex = dx
            ey = y + 18

            fx = ex
            fy = ey

        end

        d2d.kh_fill_flow(  ax+flowoffsetx,  ay+flowoffsety,  bx+flowoffsetx,  by+flowoffsety,  cx+flowoffsetx,  cy+flowoffsety,  dx+flowoffsetx,  dy+flowoffsety,  ex+flowoffsetx,  ey+flowoffsety,  fx+flowoffsetx,  fy+flowoffsety,  thickness, outColor)

        if( flow == flowMax) then
            local maximum = d2d.Image.new("KH/max.png")
            d2d.image(maximum, x+109 , y-4)
        end
    end

    ax = x + 40
    ay = y + 18
    bx = x + 40
    by = y + 18 - flow_shigh
    cx = x + 40 + flow_slength
    cy = y + 18 - flow_shigh
    dx = x + 40 + flow_slength + flow_blength
    dy = y + 18 - flow_shigh - flow_bhigh
    ex = x + 40 + flow_slength + flow_blength + flow_slength
    ey = y + 18 - flow_shigh - flow_bhigh
    fx = x + 40 + flow_slength + flow_blength + flow_slength
    fy =  y + 18


    d2d.kh_draw_flow(  ax+flowoffsetx,  ay+flowoffsety,  bx+flowoffsetx,  by+flowoffsety,  cx+flowoffsetx,  cy+flowoffsety,  dx+flowoffsetx,  dy+flowoffsety,  ex+flowoffsetx,  ey+flowoffsety,  fx+flowoffsetx,  fy+flowoffsety,  thickness, 0xFF090209)

    if lowFocus > 0 then
        d2d.fill_rect(ax, ay-2, currentFocus*flow_total/100, 5, 0xFFEEEEEE)
        d2d.outline_rect(ax, ay-2, flow_total, 5, 1, 0xFF050209)
    end

    if class == "snow.player.SlashAxe" then
        if(currentFocus > lowFocus) then
            local switch = d2d.Image.new("KH/metamaxe.png")
            d2d.image(switch, x+176 , y-15)
        else
            local switch = d2d.Image.new("KH/axe.png")
            d2d.image(switch, x+176 , y-15)
        end
    end
end

local function drawHammer(x,y,charge)

    if(charge > 0) then
        local hammer = d2d.Image.new("KH/axe.png")
        d2d.image(hammer, x+66 , y-15)
    else
        local hammer = d2d.Image.new("KH/metamaxe.png")
        d2d.image(hammer, x+66 , y-15)
    end

end

local function drawGunLance(x,y,charge, bullets, maxBullets , reloadTime)

    local barLength=100

    if reloadTime > 0 then
        d2d.fill_rect(x+31, y+13, math.floor(reloadTime / 2), 8, 0xFF7F31FF)
    
        d2d.outline_rect(x+31, y+13, barLength, 8, 2, 0xFF050209)
    end

    if charge == true then
        local gun = d2d.Image.new("KH/chargedspear.png")
        d2d.image(gun, x+66 , y-20)
    else
        local gun = d2d.Image.new("KH/spear.png")
        d2d.image(gun, x+66 , y-20)
    end

    local coffset = x+ 152
    local black

    if bullets > 0 then
        black = d2d.Image.new("KH/card_black.png")
    else
        black = d2d.Image.new("KH/card_red.png")
    end


    for i = 1, maxBullets ,1 
    do 
        coffset = coffset + 31
        d2d.image(black, coffset, y-20)
    end

    coffset = x+ 152

    loaded = d2d.Image.new("KH/card_king.png")

    for i = 1, bullets ,1 
    do 
        coffset = coffset + 31
        d2d.image(loaded, coffset, y-20)
    end
end

local function drawCharge(x, y, shield_timer, axe_timer, bottle_count, max_bottles, charge_gauge, axe_mode)

    if axe_timer > 0 then
        local key = d2d.Image.new("KH/red_key.png")
        d2d.image(key, x+74 , y-20)
    else
        local key = d2d.Image.new("KH/white_key.png")
        d2d.image(key, x+74 , y-20)
    end

    if shield_timer > 0 then
        local shield = d2d.Image.new("KH/red_logo.png")
        d2d.image(shield, x+110 , y-20)
    else
        local shield = d2d.Image.new("KH/white_logo.png")
        d2d.image(shield, x+110 , y-20)
    end

    local coffset = x + 130

    local name = "KH/card_black.png"
    local card

    if charge_gauge > 79 then
        name ="KH/card_white.png"
    elseif charge_gauge > 50 then
        name ="KH/card_red.png"
    elseif charge_gauge > 31 then
        name ="KH/card_yellow.png"
    elseif charge_gauge > 0 then
        name ="KH/card_black.png"
    end

    black = d2d.Image.new(name)

    for i = 1, max_bottles ,1 
    do 
        coffset = coffset + 31
        d2d.image(black, coffset, y-20)
    end

    coffset = x+ 130

    loaded = d2d.Image.new("KH/card_thunder.png")

    for i = 1, bottle_count ,1 
    do 
        coffset = coffset + 31
        d2d.image(loaded, coffset, y-20)
    end

end

local function drawBow(x,y,charge)

    if(charge > -1) then
        charge = charge + 1
        local number = d2d.Image.new("KH/".. charge .. ".png")
        d2d.image(number, x-28 , y-24)
    end

end

local function onDraw()

    
    --d2d.text(font,tostring(switch_flow) , 150, 150, 0xFFFFFFFF)

    if in_quest == false then
        return
    end

    if nowHP == 0 then
        return
    end
        
    x = conf.x
    y = conf.y

    local screen_w, screen_h = d2d.surface_size()
    local n = 1
    
    percentSharpness = currentSharpness * 100 / maxSharpness

    if percentSharpness>75 then
        n = 4
    elseif percentSharpness>50 then 
        n = 3
    elseif percentSharpness>25 then
        n = 2 
    end

    if maxLv == currentLv and percentSharpness>75 then
        n = 5
    end


    if debuff == 4294967296 then
        status = 3
    else
        status = 1
    end

    if currentSharpness > 0 then
        local khbarb = d2d.Image.new("KH/sh" .. tostring(currentLv) .. ".png")
        d2d.image(khbarb, x -30, y-20)

        local khbar = d2d.Image.new("KH/sbar" .. tostring(n) .. ".png")
        d2d.image(khbar, x -30, y-20)
    end


    -------------------------------------------------------------------

    local coef = 2.6

    local sa = 0
    local ea = 270
    local rsa = ea
    local rea = 270
    
    local mextra = (maxHP - treshold) * coef
    local rextra = 0

    if (nowHP >= treshold) then

        extra = (nowHP - treshold) * coef
        rextra = (recupHP)*coef;    
        fextra = (recupHP + nowHP - treshold) * coef
    
    else 
        extra = 0
        ea = ((nowHP * 270) / treshold)

        if (recupHP >= (treshold - nowHP)) then
            rsa = ea; 
            rea = 270; 
            rextra = (recupHP - (treshold - nowHP)) * coef
            fextra = (recupHP + nowHP - treshold) * coef
        
        elseif (recupHP > 0 and recupHP < (treshold - nowHP)) then
            rsa = ea; 
            rea = ((nowHP + recupHP) * 270) / treshold
            rextra = 0;
            fextra = (recupHP + nowHP - treshold) * coef
        end
    end


    local angle = 0
    local angle2 = 0
    local r = 60
    local t = 20
    local thickness = 2
    local ax, ay, bx, by, cx, cy, dx, dy = 0

    if (sa >= 90 and sa <= 270) then
        ax = x -  math.abs(( math.cos( math.rad(sa)) * r))
        bx = x -  math.abs(( math.cos( math.rad(sa)) * (r - t)))
    
    else
        ax = x +  math.abs(( math.cos( math.rad(sa)) * r))
        bx = x +  math.abs(( math.cos( math.rad(sa)) * (r - t)))
    end

    if (sa >= 0 and sa <= 180) then
        ay = y -  math.abs((math.sin( math.rad(sa)) * r))
        by = y -  math.abs((math.sin( math.rad(sa)) * (r - t)))
    
    else 
        ay = y +  math.abs((math.sin( math.rad(sa)) * r))
        by = y +  math.abs((math.sin( math.rad(sa)) * (r - t)))
    end

    if (ea >= 90 and ea <= 270) then
        cx = x -  math.abs(( math.cos( math.rad(ea)) * r))
        dx = x -  math.abs(( math.cos( math.rad(ea)) * (r - t)))
    
    else 
        cx = x +  math.abs(( math.cos( math.rad(ea)) * r))
        dx = x +  math.abs(( math.cos( math.rad(ea)) * (r - t)))
    end

    if (ea >= 0 and ea <= 180) then
        cy = y -  math.abs((math.sin( math.rad(ea)) * r))
        dy = y -  math.abs((math.sin( math.rad(ea)) * (r - t)))
    
    else
        cy = y +  math.abs((math.sin( math.rad(ea)) * r))
        dy = y +  math.abs((math.sin( math.rad(ea)) * (r - t)))
    end


    if (rea >= 90 and rea <= 270) then
        ex = x -  math.abs(( math.cos( math.rad(rea)) * r))
        fx = x -  math.abs(( math.cos( math.rad(rea)) * (r - t)))
    
    else 
        ex = x +  math.abs(( math.cos( math.rad(rea)) * r))
        fx = x +  math.abs(( math.cos( math.rad(rea)) * (r - t)))
    end

    if (rea >= 0 and rea <= 180) then
        ey = y -  math.abs((math.sin( math.rad(rea)) * r))
        fy = y -  math.abs((math.sin( math.rad(rea)) * (r - t)))
    
    else 
        ey = y +  math.abs((math.sin( math.rad(rea)) * r))
        fy = y +  math.abs((math.sin( math.rad(rea)) * (r - t)))
    end


    angle = (ea - sa)
    angle2 = (rea - rsa)

    
    if recupHP > 0 then
        d2d.kh_fill_arc( cx, cy, dx, dy, ex, ey, fx, fy, fextra, r, angle2, t, 2, 2)
    end
    d2d.kh_fill_arc( ax, ay, bx, by, cx, cy, dx, dy, extra, r, angle, t, 2, status)
    d2d.kh_draw_arc( x + r, y , x, y + r, x, y + r -t, x + r -t , y , mextra, r, t, 2, 0xFF050209)

    if lanterne > 0 then
        d2d.fill_rect( x+mextra - 150,y + r, lanterne* 3, 8, 0xFF7F31FF)
        d2d.outline_rect(x+mextra - 150 , y + r, 150, 8, 2, 0xFF050209)
    end

    local staminaSize = 250

    local fill = currentStamina * staminaSize / maxStamina

    
    local xoostoffset = 30
    local yoostoffset = 30

    d2d.fill_rounded_rect(y + yoostoffset + 6, x +xoostoffset, screen_w - (screen_w  -x) + fill + xoostoffset, screen_h - ( screen_h - y) + 20+ 6 , 2, 2, 0xFF2288FF)
    d2d.draw_rounded_rect(y + yoostoffset + 6, x +xoostoffset, screen_w - (screen_w  -x) + staminaSize + xoostoffset, screen_h - ( screen_h - y) + 20 + 6, 2, 2, 0xFF000000)

    if class == "snow.player.LongSword" then
        local color
        if long_lvl == 3 then
            long_max = 3600
            color = 0xFFb82002
        elseif long_lvl == 2 then
            long_max = 10800
            color = 0xFFFCBA03
            
        elseif long_lvl == 1 then
            long_max = 18000
            color = 0xEEd9d6d0
        else
            long_max = 18000
            color = 0xFFFFFFFF
        end

        drawFlow(x,y,thickness,color,long_gauge,100,long_gaugeTimer,long_max)
        
    end

    if class == "snow.player.GunLance" then
        drawGunLance(x,y,gunlance_canUsePile, gunlance_getBulletCount, gunlance_getMaxBulletCount ,gunlance_getReloadTime)
    end

    if class == "snow.player.Hammer" then
        drawHammer(x,y,hammer_charge)
    end

    if class == "snow.player.SlashAxe" then
        drawFlow(x,y,thickness,1,switch_currentFocus,switch_lowFocus,switch_flow,switch_flowMax)
    end

    if class == "snow.player.ChargeAxe" then
       drawCharge(x, y, charge_shield_timer, charge_axe_timer, charge_chargeBottle_num, charge_maxBottles, charge_BootleGauge, charge_axe_mode)
    end

    if class == "snow.player.Bow" then
        drawBow(x,y,bow_charge)
    end

    if class == "snow.player.DualBlades" then
        drawFlow(x,y,2,1,-1,-1,dual_gauge, dual_max)
    end

    if class == "snow.player.Horn" then
        drawFlow(x,y,2,1,-1,-1,hunt_revolt, 100)
    end

end



d2d.register(function()
    font = d2d.Font.new("Tahoma", 50)
end, onDraw)

sdk.hook(
   sdk.find_type_definition("snow.player.PlayerManager"):get_method("update"), 
   on_player_update, 
    function(retval) end)

